/* Saved in UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c00_common;

//env -class-path B62_Lib_Pkg.jar

import java.util.*;
import java.util.function.*;
import java.util.regex.*;
import java.util.stream.*;
import eu.pedu.lib20s.canvas.*;
import eu.pedu.lib20s.geom.*;
import eu.pedu.lib20s.util.*;



/*******************************************************************************
 * Knihovní třída {@code Start_26} je ekvivalentem stejnojmenného
 * startovního skriptu.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class Start_26
{
//\CC== CLASS CONSTANTS (CONSTANT CLASS/STATIC ATTRIBUTES/FIELDS) ==============
//\CV== CLASS VARIABLES (VARIABLE CLASS/STATIC ATTRIBUTES/FIELDS) ==============



//##############################################################################
//\CI== CLASS (STATIC) INITIALIZER (CLASS CONSTRUCTOR) =========================
//\CF== CLASS (STATIC) FACTORY METHODS =========================================
//\CG== CLASS (STATIC) GETTERS AND SETTERS =====================================
//\CM== CLASS (STATIC) REMAINING NON-PRIVATE METHODS ===========================

public static
/***************************************************************************
 * Klon metody ze standardní knihovny.
 *
 * @param obj Objekt, jehož textová podoba se má vytisknout
 */ void println(Object obj)
{
    System.out.println(obj);
}


public static
/***************************************************************************
 * Klon metody ze standardní knihovny.
 *
 * @param obj Objekt, jehož textová podoba se má vytisknout
 */ void print(Object obj)
{
    System.out.print(obj);
}


public static
/**************************************************************************
 * Převede obsah dvourozměrného pole na textový řetězec tak, že
 * na první řádek vypíše zadaný titulek
 * a na každý další pak hodnotu prvku pole.
 */ String arr1toStringln(String title, Object[] arr1)
{
    var stream    = Stream.of(arr1).map(o -> o.toString());
    var collector = Collectors.joining("\n   ", title + "\n   ", "");
    var result    = stream.collect(collector);
    return result;
}


public static
/**************************************************************************
 * Převede obsah dvourozměrného pole na textový řetězec tak, že
 * na první řádek vypíše zadaný titulek
 * a na každý další pak jeden řádek pole uvozený indexem daného řádku.
 */ String arr2toString(String title, Object[][] arr2)
{
    StringBuilder sb = new StringBuilder(title);
    int index = 0;
    for(Object[] row : arr2) {
        sb.append('\n');
        sb.append(String.format("%3d: ", index++));
        sb.append(Arrays.toString(row));
    }
    return sb.toString();
}


public static
/**************************************************************************
 * Vytiskne název zadané třídy následovaný signaturami
 * atributů, konstruktorů a veřejných metod zadané třídy.
 * Seznam neobsahuje metody, které jsou pouze zděděné, ale nepřebité.
 */ void printFCM(Class<?> cls)
{
    var fields       = cls.getDeclaredFields();
    var constructors = cls.getConstructors();
    var methods      = cls.getDeclaredMethods();
    var stream = Stream.concat(Arrays.stream(fields),
                 Stream.concat(Arrays.stream(constructors),
                               Arrays.stream(methods)))
                .map(o -> o.toString());
    var collector = Collectors.joining("\n   ",
                    "\nAtributy, konstruktory a veřejné metody třídy "
                  + cls.getSimpleName() + "\n   ",
                    "");
    var result = stream.collect(collector);
    result = result.replaceAll("REPL.\\$JShell\\$.+\\$", "");
    println(result);
}


public static
/**************************************************************************
 * Vytiskne název zadané třídy následovaný signaturami
 * atributů, konstruktorů a veřejných metod mateřské třídy zadané instance.
 * Seznam neobsahuje metody, které jsou pouze zděděné, ale nepřebité.
 */ void printFCM(Object o)
{
    printFCM(o.getClass());
}

public static
/**************************************************************************
 * Vrátí informacio to, shodujíli se zadané parametry
 * se zadanou relativní přesností.
 * @param d1 První z porovnávaných hodnot
 * @param d2 Druhá z porovnávaných hodnot
 * @param precision Zadaná lativní přesnost
 */ boolean equalsDouble(double d1, double d2, double precision)
{
    double max = Math.max(Math.abs(d1), Math.abs(d2));
    double dif = (d2 - d1) / max;
    println("dif = " + dif);
    return Math.abs(dif) < precision;
}



//\CP== CLASS (STATIC) PRIVATE AND AUXILIARY METHODS ===========================

public static
/**************************************************************************
 * Převede obsah zadaného pole na textový řetězec tak, že na první řádek
 * vypíše zadaný titulek a na další řádek seznam čárkami oddělených
 * hodnot prvků uzavřený v hranatých závorkách.
 */ String arr1toString(String title, Object[] arr1)
{
    return title + "\n" + Arrays.toString(arr1);
}


public static
/**************************************************************************
 * Vrátí string, na jehož prvním řádku je název zadané třídy
 * a na každém dalším řádku pak signatura deklarované metody.
 * Seynam neobsahuje metody, které jsou pouze zděděné, ale nepřebité.
 */ void printCM(Class<?> cls)
{
    var constructors = cls.getConstructors();
    var methods      = cls.getDeclaredMethods();
    var stream = Stream.concat(Arrays.stream(constructors),
                               Arrays.stream(methods))
                .map(o -> o.toString());
    var collector = Collectors.joining("\n   ",
                    "\nKonstruktory a veřejné metody třídy "
                  + cls.getSimpleName() + "\n   ",
                    "");
    var result = stream.collect(collector);
    result = result.replaceAll("REPL.\\$JShell\\$.+\\$", "");
    println(result);
}


public static
/**************************************************************************
 * Vrátí string, na jehož prvním řádku je název zadané třídy
 * a na každém dalším řádku pak signatura veřejné metody.
 */ String methods(Class<?> cls)
{
    var methods = cls.getMethods();
    var result = arr1toStringln(
                 "Veřejné metody třídy " + cls.getSimpleName(), methods);
    return result;
}


public static
/**************************************************************************
 * Vrátí string, na jehož prvním řádku je název zadané třídy
 * a na každém dalším řádku pak signatura deklarované metody.
 * Seznam neobsahuje metody, které jsou pouze zděděné, ale nepřebité.
 */ String declMethods(Class<?> cls)
{
    var methods = cls.getDeclaredMethods();
    var result = arr1toStringln(
                 "Konstruktory a veřejné metody třídy "
               + cls.getSimpleName(), methods);
    return result;
}



//##############################################################################
//\IC== INSTANCE CONSTANTS (CONSTANT INSTANCE ATTRIBUTES/FIELDS) ===============
//\IV== INSTANCE VARIABLES (VARIABLE INSTANCE ATTRIBUTES/FIELDS) ===============



//##############################################################################
//\II== INSTANCE INITIALIZERS (CONSTRUCTORS) ===================================

    /***************************************************************************
     */
    private Start_26()
    {
    }



//\IA== INSTANCE ABSTRACT METHODS ==============================================
//\IG== INSTANCE GETTERS AND SETTERS ===========================================
//\IM== INSTANCE REMAINING NON-PRIVATE METHODS =================================
//\IP== INSTANCE PRIVATE AND AUXILIARY METHODS =================================



//##############################################################################
//\NT== NESTED DATA TYPES ======================================================
}
