/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c17_inheritance;



/*******************************************************************************
 * Knihovní třída {@code Reports} obsahuje sadu metod sloužících k demonstraci
 * průběhu některých činností při konstrukci objektů a jejich používání.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class Reports
{
//== CONSTANT CLASS ATTRIBUTES =================================================
//== VARIABLE CLASS ATTRIBUTES =================================================



//##############################################################################
//== STATIC INITIALIZER (CLASS CONSTRUCTOR) ====================================
//== CLASS GETTERS AND SETTERS =================================================
//== OTHER NON-PRIVATE CLASS METHODS ===========================================

    /***************************************************************************
     * Metoda pro výpis zprávy konstruktoru o typu konstruovaného objektu
     * spolu s typem aktuálně konstruovaného podobjektu.
     *
     * @param instance Instance výsledného konstruovaného objektu
     * @param cls      Class-objekt třídy volajícího konstruktoru
     */
    public static void constructorReport(Object instance, Class<?> cls)
    {
        Class<?> instanceCls = instance.getClass();
        boolean  topType     = instanceCls.equals(cls);
        String callingClass  = cls        .getSimpleName();
        String instanceClass = instanceCls.getSimpleName();
        String indent        = "                        "
                             .substring(0, callingClass.length()+2);
        System.out.println(callingClass + ": Vytvářím " + instance + "\n"+
            (topType ? ""
                     : indent + "jako rodičovský podobjekt objektu typu " +
                       instanceClass));
    }


    /***************************************************************************
     * Pomocná metoda -- vytiskne argument na standardní výstup
     * a vrátí jej jako funkční hodnotu.
     *
     * @param input Tištěný a vracený objekt
     * @return Argument
     */
    public static String intermezzo(String input)
    {
        System.out.println(input);
        return input;
    }


    /***************************************************************************
     * Vytiskne podpis argumentu na standardní výstup.
     *
     * @param object Tištěný objekt
     */
    public static void println(Object object)
    {
        System.out.println(object);
    }



//== PRIVATE AND AUXILIARY CLASS METHODS =======================================



//##############################################################################
//== CONSTANT INSTANCE ATTRIBUTES ==============================================
//== VARIABLE INSTANCE ATTRIBUTES ==============================================



//##############################################################################
//== CONSTRUCTORS AND FACTORY METHODS ==========================================

    /***************************************************************************
     * Soukromý konstruktor zabraňující vytvoření instance.
     */
    private Reports()
    {
    }



//== ABSTRACT METHODS ==========================================================
//== INSTANCE GETTERS AND SETTERS ==============================================
//== OTHER NON-PRIVATE INSTANCE METHODS ========================================
//== PRIVATE AND AUXILIARY INSTANCE METHODS ====================================



//##############################################################################
//== NESTED DATA TYPES =========================================================
}
