/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c18_visibility;

import static eu.pedu.b62_j14.c18_visibility.Reports.*;



/*******************************************************************************
 * Instance třídy {@code Mother} představují matky.
 * Třída je součástí skupiny tříd využívajících dědění.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class Mother implements IMother
{
//== CONSTANT CLASS ATTRIBUTES =================================================
//== VARIABLE CLASS ATTRIBUTES =================================================

    /** Počet doposud vytvořených instancí –
     *  tento atribut může být v potomcích zakryt, nicméně zůstane přístupný.*/
    private static int created = 0;



//##############################################################################
//== STATIC INITIALIZER (CLASS CONSTRUCTOR) ====================================
//== CLASS GETTERS AND SETTERS =================================================
//== OTHER NON-PRIVATE CLASS METHODS ===========================================

    /***************************************************************************
     * Vypíše jednoduchý název třídy, v níž je metoda definována,
     * a v závorkách jednoduchý název třídy, jíž byla poslána zpráva.
     *
     * @param cls Class-objekt třídy, jíž byla zaslána zpráva
     */
    protected static void protectedStatic(Class<?> cls)
    {
        System.out.println("Mother: protectedStatic("
                            + cls.getSimpleName() + ")");
    }



//== PRIVATE AND AUXILIARY CLASS METHODS =======================================



//##############################################################################
//== CONSTANT INSTANCE ATTRIBUTES ==============================================

    /** Rodné číslo instance = pořadí jejího vzniku v rámci této třídy.
     *  Tento atribut může být v potomcích zakryt, nicméně zůstane přístupný.*/
    protected final String ID = "M"  + ++created;



//== VARIABLE INSTANCE ATTRIBUTES ==============================================



//##############################################################################
//== CONSTRUCTORS AND FACTORY METHODS ==========================================

    /***************************************************************************
     * Konstruktor instance matky.
     * Rodičovským podobjektem je virtuální instance třídy {@link Object}.
     */
    public Mother()
    {
//        constructorReport(this, Mother.class);
    }



//== ABSTRACT METHODS ==========================================================
//== INSTANCE GETTERS AND SETTERS ==============================================

    /***************************************************************************
     * Virtuální metoda vracející identifikační kód instance {@code this}.
     *
     * @return Identifikační kód ("rodné číslo") instance
     */
    public String getID()
    {
        return ID;
    }



//== OTHER NON-PRIVATE INSTANCE METHODS ========================================

    /***************************************************************************
     * Vypíše jednoduchý název třídy, v níž je metoda definována,
     * a v závorkách podpis instance, jíž byla zaslána zpráva.
     */
//    @Override
    protected void protectedInstance()
    {
        System.out.println("Mother: (" + this + ")");
    }


    /***************************************************************************
     * Vrátí textový podpis instance, tj. její řetězcovou reprezentaci.
     *
     * @return Textová reprezentace (podpis) dané instance
     */
    @Override
    public String toString()
    {
        return "Mother_" + ID + "(Object)";
    }



//== PRIVATE AND AUXILIARY INSTANCE METHODS ====================================



//##############################################################################
//== NESTED DATA TYPES =========================================================
}
