/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c19_virtual;

import static eu.pedu.b62_j14.c19_virtual.Reports.*;



/*******************************************************************************
 * Instance třídy {@code Daughter} představují dcery.
 * Třída je součástí skupiny tříd využívajících dědění.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class Daughter
     extends Mother
{
//== CONSTANT CLASS ATTRIBUTES =================================================
//== VARIABLE CLASS ATTRIBUTES =================================================

    /** Počet doposud vytvořených instancí –
     *  tento atribut může být v potomcích zakryt, nicméně zůstane přístupný.*/
    private static int created = 0;



//##############################################################################
//== STATIC INITIALIZER (CLASS CONSTRUCTOR) ====================================
//== CLASS GETTERS AND SETTERS =================================================
//== OTHER NON-PRIVATE CLASS METHODS ===========================================
//== PRIVATE AND AUXILIARY CLASS METHODS =======================================



//##############################################################################
//== CONSTANT INSTANCE ATTRIBUTES ==============================================

    /** Rodné číslo instance = pořadí jejího vzniku v rámci této třídy.
     *  Tento atribut může být v potomcích zakryt, nicméně zůstane přístupný.*/
    protected final String ID = "D"  + ++created + '-' + super.ID;



//== VARIABLE INSTANCE ATTRIBUTES ==============================================



//##############################################################################
//== CONSTRUCTORS AND FACTORY METHODS ==========================================

    /***************************************************************************
     * Konstruktor instance dcery.
     * Rodičovským podobjektem je virtuální instance třídy {@link Mother}.
     */
    public Daughter()
    {
//        constructorReport(this, Daughter.class);
    }



//== ABSTRACT METHODS ==========================================================
//== INSTANCE GETTERS AND SETTERS ==============================================

    /***************************************************************************
     * Virtuální metoda vracející identifikační kód instance {@code this}.
     *
     * @return Identifikační kód ("rodné číslo") instance
     */
    @Override
    public String getID()
    {
        return ID;
    }



//== OTHER NON-PRIVATE INSTANCE METHODS ========================================

    /***************************************************************************
     * Metoda pro demonstraci chování virtuálních metod
     * deklarovaná v matce, nikde nepřebitá.
     * Zakomentovaná verze použitá pro snažší srovnání zdrojových kódů.
     */
//    @Override
//    public void virtualM__()
//    {
//        report( this, "Verze dcery  - " +
//                      "M__ - Deklarovaná v matce, nikde nepřebitá");
//    }


    /***************************************************************************
     * Metoda pro demonstraci chování virtuálních metod
     * deklarovaná v matce, přebitá dcerou.
     * Živá verze použitá v demonstračním programu.
     */
    @Override
    public void virtualMD_()
    {
        report( this, "Verze dcery  - " +
                      "MD_ - Deklarovaná v matce, přebitá dcerou");
    }


    /***************************************************************************
     * Metoda pro demonstraci chování virtuálních metod
     * deklarovaná v matce, přebitá až vnučkou.
     * Zakomentovaná verze použitá pro snažší srovnání zdrojových kódů.
     */
//    @Override
//    public void virtualM_G()
//    {
//        report( this, "Verze dcery  - " +
//                      "M_G - Deklarovaná v matce, přebitá až vnučkou");
//    }


    /***************************************************************************
     * Metoda pro demonstraci chování virtuálních metod
     * deklarovaná v matce, přebitá dcerou i vnučkou.
     * Živá verze použitá v demonstračním programu.
     */
    @Override
    public void virtualMDG()
    {
        report( this, "Verze dcery  - " +
                      "MDG - Deklarovaná v matce, přebitá dcerou i vnučkou");
    }


    /***************************************************************************
     * Metoda pro demonstraci chování virtuálních metod
     * deklarovaná v dceři, nikde nepřebitá.
     * Živá verze použitá v demonstračním programu.
     */
//    @Override
    public void virtual_D_()
    {
        report( this, "Verze dcery  - " +
                      "_D_ - Deklarovaná v dceři, nikde nepřebitá");
    }


    /***************************************************************************
     * Metoda pro demonstraci chování virtuálních metod
     * deklarovaná v dceři, přebitá vnučkou.
     * Živá verze použitá v demonstračním programu.
     */
//    @Override
    public void virtual_DG()
    {
        report( this, "Verze dcery  - " +
                      "_DG - Deklarovaná v dceři, přebitá vnučkou");
    }


    /***************************************************************************
     * Metoda pro demonstraci chování virtuálních metod
     * deklarovaná ve vnučce, nikde nepřebitá.
     * Zakomentovaná verze použitá pro snažší srovnání zdrojových kódů.
     */
//    @Override
//    public void virtual__G()
//    {
//        report( this, "Verze dcery  - " +
//                      "__G - Deklarovaná ve vnučce, nikde nepřebitá");
//    }


    /***************************************************************************
     * Metoda postupně zavolá všechny virtuální metody své instance.
     * Tato verze volá všechny metody explicitně.
     */
    public final void summaryDe()
    {
        System.out.println("Explicitní volání virtuálních metod třídy: " +
                           Daughter.class.getSimpleName());
         this.virtualM__();      this.virtualMD_();
         this.virtualM_G();      this.virtualMDG();
         this.virtual_D_();      this.virtual_DG ();
    }


    /***************************************************************************
     * Vrátí textový podpis instance, tj. její řetězcovou reprezentaci.
     *
     * @return Textová reprezentace (podpis) dané instance
     */
    @Override
    public String toString()
    {
        return "Daughter_" + ID + "(" + super.toString() + ")";
    }



//== PRIVATE AND AUXILIARY INSTANCE METHODS ====================================



//##############################################################################
//== NESTED DATA TYPES =========================================================
}
