/* UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c19_virtual;

import eu.pedu.lib20s.dbg.IndentingReporter;



/*******************************************************************************
 * Instance třídy {@code TestVirtual} představují ...
 * The {@code TestVirtual} class instances represent ...
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class TestVirtual
{
//\CC== CLASS CONSTANTS (CONSTANT CLASS/STATIC ATTRIBUTES/FIELDS) ==============

    /** Zpravodaj o volajících metodách. */
    private static IndentingReporter IR;



//\CV== CLASS VARIABLES (VARIABLE CLASS/STATIC ATTRIBUTES/FIELDS) ==============



//##############################################################################
//\CI== CLASS (STATIC) INITIALIZER (CLASS CONSTRUCTOR) =========================
//\CF== CLASS (STATIC) FACTORY METHODS =========================================
//\CG== CLASS (STATIC) GETTERS AND SETTERS =====================================
//\CM== CLASS (STATIC) REMAINING NON-PRIVATE METHODS ===========================
//\CP== CLASS (STATIC) PRIVATE AND AUXILIARY METHODS ===========================

    /***************************************************************************
     * Report objektů vydávajících se za matku.
     *
     * @param subject   Označení skutečné povahy objektu
     * @param mother    Objekt vydávající se za matku
     */
    private static void motherReport(String subject, Mother mother)
    {
        IR.reportStart(subject + " vydávající se za matku");
        mother.summaryMe();
        IR.reportEnd();
    }


    /***************************************************************************
     * Report objektů vydávajících se za dceru.
     *
     * @param subject   Označení skutečné povahy objektu
     * @param daughter  Objekt vydávající se za dceru
     */
    private static void daughterReport(String subject, Daughter daughter)
    {
        IR.reportStart(subject + " vydávající se za dceru");
        daughter.summaryDe();
        IR.reportEnd();
    }


    /***************************************************************************
     * Report objektů vydávajících se za vnučku.
     *
     * @param subject       Označení skutečné povahy objektu
     * @param granddaughter Objekt vydávající se za vnučku
     */
    private static void granddaughterReport(String subject,
                                            Granddaughter granddaughter)
    {
        IR.reportStart(subject + " vydávající se za vnučku");
        granddaughter.summaryGe();
        IR.reportEnd();
    }


    /***************************************************************************
     * Testuje volání virtuálních metod objektů v přípravku
     * prostřednictvím metod z rodiny {@code ???ExplReport}.
     */
    public static void testReportByRole()
    {
        Mother        mother        = new Mother();
        Daughter      daughter      = new Daughter();
        Granddaughter granddaughter = new Granddaughter();

        IR.reportStart("Reporty objektů vydávajících se za matku"); {
            motherReport("Matka",  mother);
            motherReport("Dcera",  daughter);
            motherReport("Vnučka", granddaughter);
        }IR.reportEnd();
        IR.reportStart("Reporty objektů vydávajících se za dceru"); {
            daughterReport("Dcera",  daughter);
            daughterReport("Vnučka", granddaughter);
        }IR.reportEnd();
        IR.reportStart("Reporty objektů vydávajících se za vnučku");{
            granddaughterReport("Vnučka", granddaughter);
        }IR.reportEnd();
    }


    /***************************************************************************
     * Testuje volání virtuálních metod objektů v přípravku
     * prostřednictvím metod z rodiny {@code ???ExplReport}.
     */
    public static void testReportByMother()
    {
        Mother        mother        = new Mother();
        Daughter      daughter      = new Daughter();
        Granddaughter granddaughter = new Granddaughter();

        IR.reportStart("Reporty instance matky"); {
            motherReport("Matka",  mother);
        }IR.reportEnd();
        IR.reportStart("Reporty instance dcery"); {
            motherReport  ("Dcera",  daughter);
            daughterReport("Dcera",  daughter);
        }IR.reportEnd();
        IR.reportStart("Reporty instance vnučky");{
            motherReport       ("Vnučka", granddaughter);
            daughterReport     ("Vnučka", granddaughter);
            granddaughterReport("Vnučka", granddaughter);
        }IR.reportEnd();
    }



//##############################################################################
//\IC== INSTANCE CONSTANTS (CONSTANT INSTANCE ATTRIBUTES/FIELDS) ===============
//\IV== INSTANCE VARIABLES (VARIABLE INSTANCE ATTRIBUTES/FIELDS) ===============



//##############################################################################
//\II== INSTANCE INITIALIZERS (CONSTRUCTORS) ===================================

    /***************************************************************************
     */
    public TestVirtual()
    {
    }



//\IA== INSTANCE ABSTRACT METHODS ==============================================
//\IG== INSTANCE GETTERS AND SETTERS ===========================================
//\IM== INSTANCE REMAINING NON-PRIVATE METHODS =================================
//\IP== INSTANCE PRIVATE AND AUXILIARY METHODS =================================



//##############################################################################
//\NT== NESTED DATA TYPES ======================================================



//##############################################################################
//== MAIN METHOD ===============================================================

    /***************************************************************************
     * Metoda spouštějící celou aplikaci.
     *
     * @param args Parametry příkazového řádku
     */
    public static void main(String[] args)
    {
        IR = IndentingReporter.getSystemReporter();
        testReportByRole();
        System.out.println("################################################");
        testReportByMother();
    }
}
