/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c22_generics;



/*******************************************************************************
 * Třída {@code GenericCrate2Test} slouží k otestování vlastností třídy
 * {@link GenericCrate2}.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class GenericCrate2Test
{
    public static void main(String[] args)
    {
        GenericCrate2<String, Integer> stringInteger;
        GenericCrate2<Integer, String> integerString;

        //Autoboxing převede int na Integer
        stringInteger = new GenericCrate2<>("První", 1);
        integerString = new GenericCrate2<>(2, "Druhý");
    //    stringInteger = new GenericCrate2<>(1, "První");  //Špatné pořadí typů
    //    integerString = new GenericCrate2<>("Druhý", 2);  //Špatné pořadí typů
        System.out.println("Vytvořeny přepravky:\n  " + stringInteger +
                                               "\n  " + integerString);

        String string1, string2;
        string1 = stringInteger.getV1();
        string2 = integerString.getV2();
    //    string1 = stringInteger.getV2();   //Špatný typ návratové hodnoty
    //    string2 = integerString.getV1();   //Špatný typ návratové hodnoty
        System.out.println("Textové hodnoty: string1=" + string1 +
                                          ", string2=" + string2);

        int int1, int2;    //Autounboxing převede Integer na int
        int1 = stringInteger.getV2();
        int2 = integerString.getV1();
    //    int1 = stringInteger.getV1();   //Špatný typ návratové hodnoty
    //    int2 = integerString.getV2();   //Špatný typ návratové hodnoty
        System.out.println("Celočíselné hodnoty: int1=" + int1 +
                                              ", int2=" + int2);

        //Typovým argumentem může být i generický typ
        GenericCrate2
            <GenericCrate2<String, Integer>, GenericCrate2<Integer, String>>
            composite = new GenericCrate2<>(stringInteger, integerString);
        System.out.println("Složenina:\n  " + composite);
    }
}
