/* UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c22_generics;



public class ThrowsTypeArgument<T extends Throwable>
{
    Class<T> excClass;

    public ThrowsTypeArgument(Class<T> excClass) {
        this.excClass = excClass;
        System.err.println("Vytvářím objekt s výjimkou typu " + excClass);
    }

    public void throwing()  throws T
    {
        try {
            T toThrow = excClass.getConstructor().newInstance();
            System.err.println(" - Vyhazuji výjimku " + toThrow );
            throw toThrow;
        }
        catch(Exception e) {
            throw new RuntimeException("Nepovedlo se vytvořit výjimku", e );
        }
    }

    public static <U extends Throwable> void prověř(ThrowsTypeArgument<U> v)
    {
        try {
            System.err.println("Volám s parametrem " + v);
            v.throwing();
            System.err.println("Operace zdárně prošla");
        }catch( Throwable t) {
            System.err.println("Operace vyhodila výjimku " + t);
            System.err.println("  Zpráva: " + t.getMessage());
        }
        System.err.println("==============");
    }

//===== TESTY =================================================================

//##############################################################################
//== MAIN METHOD ===============================================================

    /***************************************************************************
     * Metoda spouštějící celou aplikaci.
     *
     * @param args Parametry příkazového řádku
     */
    @SuppressWarnings({"unchecked", "rawtypes"})
    public static void main(String[] args)
    {
        System.err.println("==============");
        prověř(new ThrowsTypeArgument(Throwable.class));
        prověř(new ThrowsTypeArgument<Exception>( Exception.class ) );
        prověř(new ThrowsTypeArgument<RuntimeException>( RuntimeException.class ) );
    }
}
