/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c23_typearguments;



/*******************************************************************************
 * Třída {@code MathT} ja knihovní třídou poskytující
 * různé matematické a pomocné funkce nad instancemi objektových typů.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class MathT
{
//== CONSTANT CLASS ATTRIBUTES =================================================
//== VARIABLE CLASS ATTRIBUTES =================================================



//##############################################################################
//== STATIC INITIALIZER (CLASS CONSTRUCTOR) ====================================
//== CLASS GETTERS AND SETTERS =================================================
//== OTHER NON-PRIVATE CLASS METHODS ===========================================
//== PRIVATE AND AUXILIARY CLASS METHODS =======================================

    /***************************************************************************
     * Vrátí menší z hodnot, přesněji
     * vrátí instanci, jež je považována za "menší".
     *
     * @param <T> Typ porovnávaných objektů
     * @param t1  První z porovnávaných objektů
     * @param t2  Druhý z porovnávaných objektů
     * @return    "Menší" z porovnávaných objektů
     */
    public static <T extends Comparable<? super T>> T max(T t1, T t2)
    {
        return (t1.compareTo(t2) < 0) ? t2 : t1;
    }


    /***************************************************************************
     * Vrátí menší ze zadaných hodnot, přesněji
     * vrátí instanci, jež je považována za "větší".
     *
     * @param <T> Typ porovnávaných objektů
     * @param t1  První z porovnávaných objektů
     * @param t2  Druhý z porovnávaných objektů
     * @return    "Větší" z porovnávaných objektů
     */
    public static <T extends Comparable<? super T>> T min(T t1, T t2)
    {
        return (t1.compareTo(t2) < 0) ? t1 : t2;
    }



//##############################################################################
//== CONSTANT INSTANCE ATTRIBUTES ==============================================
//== VARIABLE INSTANCE ATTRIBUTES ==============================================



//##############################################################################
//== CONSTRUCTORS AND FACTORY METHODS ==========================================

    /** Soukromý konstruktor zabraňující vytvoření instance.*/
    private MathT() {}



//== ABSTRACT METHODS ==========================================================
//== INSTANCE GETTERS AND SETTERS ==============================================
//== OTHER NON-PRIVATE INSTANCE METHODS ========================================
//== PRIVATE AND AUXILIARY INSTANCE METHODS ====================================



//##############################################################################
//== NESTED DATA TYPES =========================================================
}
