/* UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.c25_enums;



/*******************************************************************************
 * Instance třídy {@code SeasonUtil} představují ...
 * The {@code SeasonUtil} class instances represent ...
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class SeasonUtil
{
//\CC== CLASS CONSTANTS (CONSTANT CLASS/STATIC ATTRIBUTES/FIELDS) ==============
//\CV== CLASS VARIABLES (VARIABLE CLASS/STATIC ATTRIBUTES/FIELDS) ==============



//##############################################################################
//\CI== CLASS (STATIC) INITIALIZER (CLASS CONSTRUCTOR) =========================
//\CF== CLASS (STATIC) FACTORY METHODS =========================================
//\CG== CLASS (STATIC) GETTERS AND SETTERS =====================================
//\CM== CLASS (STATIC) REMAINING NON-PRIVATE METHODS ===========================

public static String activity_1(Season season)
{
    String s = "Rostlina ";
    switch (season)
    {
        case SPRING: return s + "kvete";
        case SUMMER: return s + "zraje";
        case AUTUMN: return s + "plodí";
        case WINTER: return s + "spí";
    }
    //Překladač nekontroluje, zda jsem všechna období vyčerpal
    return null;
}


public static String activity_2(Season season)
{
    String s = "Rostlina ";
    switch (season)
    {
        case SPRING: return s + "kvete";
        case SUMMER: return s + "zraje";
        case AUTUMN: return s + "plodí";
        case WINTER: return s + "spí";
        default:     throw new IllegalArgumentException(
                        "Neočekávaná hodnota parametru: season=" + season);
    }
}


public static String activity_3(Season season)
{
    return "Rostlina " + switch (season){
                            case SPRING -> "kvete";
                            case SUMMER -> "zraje";
                            case AUTUMN -> "plodí";
                            case WINTER -> "spí";
//                            default -> throw new IllegalArgumentException(
//                        "Neočekávaná hodnota parametru: season=" + season);
                         };
}


public static void enumerate()
{
    for (Season season : Season.values()) {
        System.out.println("V období " + season + " " + activity_3(season));
    }
}



//\CP== CLASS (STATIC) PRIVATE AND AUXILIARY METHODS ===========================



//##############################################################################
//\IC== INSTANCE CONSTANTS (CONSTANT INSTANCE ATTRIBUTES/FIELDS) ===============
//\IV== INSTANCE VARIABLES (VARIABLE INSTANCE ATTRIBUTES/FIELDS) ===============



//##############################################################################
//\II== INSTANCE INITIALIZERS (CONSTRUCTORS) ===================================

    /***************************************************************************
     */
    public SeasonUtil()
    {
    }



//\IA== INSTANCE ABSTRACT METHODS ==============================================
//\IG== INSTANCE GETTERS AND SETTERS ===========================================
//\IM== INSTANCE REMAINING NON-PRIVATE METHODS =================================
//\IP== INSTANCE PRIVATE AND AUXILIARY METHODS =================================



//##############################################################################
//\NT== NESTED DATA TYPES ======================================================


//##############################################################################
//== MAIN METHOD ===============================================================

    /***************************************************************************
     * Metoda spouštějící celou aplikaci.
     *
     * @param args Parametry příkazového řádku
     */
    public static void main(String[] args)
    {
        enumerate();
    }
}
