/* Saved in UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.b62_j14.cab_gui;

import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.Point;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.WindowConstants;



/*******************************************************************************
 * Třída {@code Swing} je koncipována jako AHA-příklad demonstrující
 * některé zásady tvorby GUI nad platformou Swing.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public class Swing
{
//\CC== CLASS CONSTANTS (CONSTANT CLASS/STATIC ATTRIBUTES/FIELDS) ==============

    /** Index vodorovné souřadnice. */  private static final int X = 0;
    /** Index svislé souřadnice.    */  private static final int Y = 1;
    /** Příznak chybně zadaného čísla. */
    private static final int BAD = Integer.MAX_VALUE;


//\CV== CLASS VARIABLES (VARIABLE CLASS/STATIC ATTRIBUTES/FIELDS) ==============



//##############################################################################
//\CI== CLASS (STATIC) INITIALIZER (CLASS CONSTRUCTOR) =========================
//\CF== CLASS (STATIC) FACTORY METHODS =========================================
//\CG== CLASS (STATIC) GETTERS AND SETTERS =====================================
//\CM== CLASS (STATIC) REMAINING NON-PRIVATE METHODS ===========================
//\CP== CLASS (STATIC) PRIVATE AND AUXILIARY METHODS ===========================



//##############################################################################
//\IC== INSTANCE CONSTANTS (CONSTANT INSTANCE ATTRIBUTES/FIELDS) ===============

    /** Aplikační okno.        */ private final JFrame  frame;
    /** Vstupní pole.          */ private final JTextField[] jtf = {null, null};
    /** Nastavované souřadnice.*/ private final int [] coordinates = {0, 0};



//\IV== INSTANCE VARIABLES (VARIABLE INSTANCE ATTRIBUTES/FIELDS) ===============



//##############################################################################
//\II== INSTANCE INITIALIZERS (CONSTRUCTORS) ===================================

    /***************************************************************************
     * Vytvoří aplikační okno a aktivuje je.
     */
    public Swing()
    {
        frame = new JFrame("Demo tvorby GUI");
        Box box = new Box(BoxLayout.Y_AXIS);  //Panel panelů vstupních polí
        frame.add(box);
        axisPanel(box, X);
        axisPanel(box, Y);
        addButtonPanel();
        frame.addComponentListener(new ComponentAdapter()
        {
            @Override public void componentMoved(ComponentEvent e)
            {
                Point p = frame.getLocation();
                coordinates[X] = p.x;       jtf[X].setText(""+p.x);
                coordinates[Y] = p.y;       jtf[Y].setText(""+p.y);
            }
        });
        frame.pack();
        frame.setAlwaysOnTop(true);
        frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        frame.setVisible(true);
    }



//\IA== INSTANCE ABSTRACT METHODS ==============================================
//\IG== INSTANCE GETTERS AND SETTERS ===========================================
//\IM== INSTANCE REMAINING NON-PRIVATE METHODS =================================
//\IP== INSTANCE PRIVATE AND AUXILIARY METHODS =================================

    /***************************************************************************
     * Vytvoří vstupní pole pro zadání hodnot dané souřadnice.
     * @param box  Panel panelů vstupních polí
     * @param axis Index položky dané souřadnice v použitých polích
     */
    private void axisPanel(Box box, int axis)
    {
        Box        panel = new Box(BoxLayout.X_AXIS);
        JTextField input = jtf[axis] = new JTextField(""+coordinates[axis]);
        panel.add(new Label("Souřadnice " + (char)('X' + axis) + ": "));
        panel.add(input);
        input.addFocusListener(new FocusAdapter()
        {
            @Override public void focusLost(FocusEvent e) {
                int value;
                try {
                    value = Integer.parseInt(input.getText().trim());
                } catch(NumberFormatException nfe) {
                    JOptionPane.showMessageDialog(null,
                        "Špatně zadané číslo\nZkuste je zadat znovu");
                    value = BAD;
                }
                coordinates[axis] = value;
            }
        });
        box.add(panel);
    }


    /***************************************************************************
     * Do jižní oblasti aplikačního okna přidá panel tlačítek.
     */
private void addButtonPanel()
{
    JPanel  panel  = new JPanel();
    frame.add(panel, BorderLayout.SOUTH);

    JButton getButton = new JButton("Načti souřadnice");
    panel.add(getButton);
    getButton.addActionListener(e -> {
        Point p = frame.getLocation();
        coordinates[X] = p.x;    jtf[X].setText(""+p.x);
        coordinates[Y] = p.y;    jtf[Y].setText(""+p.y);
    });

    JButton setButton = new JButton("Nastav souřadnice");
    panel.add(setButton);
    setButton.addActionListener(e -> {
        if ((coordinates[X] != BAD)  &&  (coordinates[Y] != BAD)) {
            frame.setLocation(coordinates[X], coordinates[Y]);
        }
    });
}



//##############################################################################
//\NT== NESTED DATA TYPES ======================================================



//##############################################################################
//== MAIN METHOD ===============================================================

    /***************************************************************************
     * Metoda spouštějící celou aplikaci.
     *
     * @param args Parametry příkazového řádku
     */
    public static void main(String[] args)
    {
        java.awt.EventQueue.invokeLater(() -> new Swing());
    }
}
