/* Saved in UTF-8 codepage: Příliš žluťoučký kůň úpěl ďábelské ódy. ÷ × ¤
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package eu.pedu.lib20s.geom;



/*******************************************************************************
 * Instance interfejsu {@code IModular} představují geometrické objekty,
 * které umějí prozradit a nastavit svoji pozici a modul.
 * Modul objektu je přitom základní rozměr, od nějž jsou dovozovány
 * všechny ostatní rozměry objektu.
 * Většinou je definován jako délka strany opsaného čtverce.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2020-Summer
 */
public interface IModular
         extends IMovable, IFlexible
{
//\CC== CLASS (STATIC) CONSTANTS ===============================================
//\CM== CLASS (STATIC) METHODS =================================================



//##############################################################################
//\AG== ABSTRACT GETTERS AND SETTERS ===========================================

    /***************************************************************************
     * Vrátí velikost modulu, tj. délku strany opsaného čtverce.
     *
     * @return   Velikost modulu instance
     */
//    @Override
    public int getModule();


    /***************************************************************************
     * Změni velikost instance, aby měl její nový modul
     * (= délku strany opsaného čtverce) zadanou velikost.
     *
     * @param module    Nově nastavovaný modul
     */
//    @Override
    public void setModule(int module);



//\AM== REMAINING ABSTRACT METHODS =============================================
//\DG== DEFAULT GETTERS AND SETTERS ============================================
//\DM== REMAINING DEFAULT METHODS ==============================================



//##############################################################################
//\NT== NESTED DATA TYPES ======================================================
}
